#line 1 "Tweak.xm"
#import "WeChatVideoDownloader.h"

static MMTableViewCell *iOSRECell;
static MMTableView *iOSREView;
static WCTimeLineViewController *iOSREController;

#include <logos/logos.h>
#include <objc/message.h>
@class WCFacade; @class WCContentItemViewTemplateNewSight; @class MMServiceCenter; 
static Class _logos_superclass$_ungrouped$WCContentItemViewTemplateNewSight; static void (*_logos_orig$_ungrouped$WCContentItemViewTemplateNewSight$onLongTouch)(WCContentItemViewTemplateNewSight*, SEL);
static __inline__ __attribute__((always_inline)) __attribute__((unused)) Class _logos_static_class_lookup$MMServiceCenter(void) { static Class _klass; if(!_klass) { _klass = objc_getClass("MMServiceCenter"); } return _klass; }static __inline__ __attribute__((always_inline)) __attribute__((unused)) Class _logos_static_class_lookup$WCFacade(void) { static Class _klass; if(!_klass) { _klass = objc_getClass("WCFacade"); } return _klass; }
#line 7 "Tweak.xm"



static WCMediaItem * _logos_method$_ungrouped$WCContentItemViewTemplateNewSight$iOSREMediaItemFromSight(WCContentItemViewTemplateNewSight* self, SEL _cmd) {
	id responder = self;
	while (![responder isKindOfClass:NSClassFromString(@"WCTimeLineViewController")])
	{
		if ([responder isKindOfClass:NSClassFromString(@"MMTableViewCell")]) iOSRECell = responder;
		else if ([responder isKindOfClass:NSClassFromString(@"MMTableView")]) iOSREView = responder;
		responder = [responder nextResponder];
	}
	iOSREController = responder;
	if (!iOSRECell || !iOSREView || !iOSREController)
	{
		NSLog(@"iOSRE: Failed to get video object.");
		return nil;
	}
	NSIndexPath *indexPath = [iOSREView indexPathForCell:iOSRECell];
	int itemIndex = [iOSREController calcDataItemIndex:[indexPath section]];
	WCFacade *facade = [(MMServiceCenter *)[_logos_static_class_lookup$MMServiceCenter() defaultCenter] getService:[_logos_static_class_lookup$WCFacade() class]];
	WCDataItem *dataItem = [facade getTimelineDataItemOfIndex:itemIndex];
	WCContentItem *contentItem = dataItem.contentObj;
	WCMediaItem *mediaItem = [contentItem.mediaList count] != 0 ? (contentItem.mediaList)[0] : nil;
	return mediaItem;
}



static void _logos_method$_ungrouped$WCContentItemViewTemplateNewSight$iOSREOnSaveToDisk(WCContentItemViewTemplateNewSight* self, SEL _cmd) {
	NSString *localPath = [[self iOSREMediaItemFromSight] pathForSightData];
	UISaveVideoAtPathToSavedPhotosAlbum(localPath, nil, nil, nil);
}



static void _logos_method$_ungrouped$WCContentItemViewTemplateNewSight$iOSREOnCopyURL(WCContentItemViewTemplateNewSight* self, SEL _cmd) {
	UIPasteboard *pasteboard = [UIPasteboard generalPasteboard];
	pasteboard.string = [self iOSREMediaItemFromSight].dataUrl.url;
}

static int iOSRECounter;


static void _logos_super$_ungrouped$WCContentItemViewTemplateNewSight$onLongTouch(WCContentItemViewTemplateNewSight* self, SEL _cmd) {return ((void (*)(WCContentItemViewTemplateNewSight*, SEL))class_getMethodImplementation(_logos_superclass$_ungrouped$WCContentItemViewTemplateNewSight, @selector(onLongTouch)))(self, _cmd);}static void _logos_method$_ungrouped$WCContentItemViewTemplateNewSight$onLongTouch(WCContentItemViewTemplateNewSight* self, SEL _cmd) {
	iOSRECounter++;
	if (iOSRECounter % 2 == 0) return;
	
	[self becomeFirstResponder];
	
	UIMenuItem *saveToDiskMenuItem = [[UIMenuItem alloc] initWithTitle:@"Save to Disk" action:@selector(iOSREOnSaveToDisk)];
	UIMenuItem *copyURLMenuItem = [[UIMenuItem alloc] initWithTitle:@"Copy URL" action:@selector(iOSREOnCopyURL)];
	
	UIMenuController *menuController = [UIMenuController sharedMenuController];
	[menuController setMenuItems:@[saveToDiskMenuItem, copyURLMenuItem]];
	[menuController setTargetRect:CGRectZero inView:self];
	[menuController setMenuVisible:YES animated:YES];
	
	[saveToDiskMenuItem release];
	[copyURLMenuItem release];
}

static __attribute__((constructor)) void _logosLocalInit() {
{Class _logos_class$_ungrouped$WCContentItemViewTemplateNewSight = objc_getClass("WCContentItemViewTemplateNewSight"); _logos_superclass$_ungrouped$WCContentItemViewTemplateNewSight = class_getSuperclass(_logos_class$_ungrouped$WCContentItemViewTemplateNewSight); { char _typeEncoding[1024]; unsigned int i = 0; memcpy(_typeEncoding + i, @encode(WCMediaItem *), strlen(@encode(WCMediaItem *))); i += strlen(@encode(WCMediaItem *)); _typeEncoding[i] = '@'; i += 1; _typeEncoding[i] = ':'; i += 1; _typeEncoding[i] = '\0'; class_addMethod(_logos_class$_ungrouped$WCContentItemViewTemplateNewSight, @selector(iOSREMediaItemFromSight), (IMP)&_logos_method$_ungrouped$WCContentItemViewTemplateNewSight$iOSREMediaItemFromSight, _typeEncoding); }{ char _typeEncoding[1024]; unsigned int i = 0; _typeEncoding[i] = 'v'; i += 1; _typeEncoding[i] = '@'; i += 1; _typeEncoding[i] = ':'; i += 1; _typeEncoding[i] = '\0'; class_addMethod(_logos_class$_ungrouped$WCContentItemViewTemplateNewSight, @selector(iOSREOnSaveToDisk), (IMP)&_logos_method$_ungrouped$WCContentItemViewTemplateNewSight$iOSREOnSaveToDisk, _typeEncoding); }{ char _typeEncoding[1024]; unsigned int i = 0; _typeEncoding[i] = 'v'; i += 1; _typeEncoding[i] = '@'; i += 1; _typeEncoding[i] = ':'; i += 1; _typeEncoding[i] = '\0'; class_addMethod(_logos_class$_ungrouped$WCContentItemViewTemplateNewSight, @selector(iOSREOnCopyURL), (IMP)&_logos_method$_ungrouped$WCContentItemViewTemplateNewSight$iOSREOnCopyURL, _typeEncoding); }{ Class _class = _logos_class$_ungrouped$WCContentItemViewTemplateNewSight;Method _method = class_getInstanceMethod(_class, @selector(onLongTouch));if (_method) {_logos_orig$_ungrouped$WCContentItemViewTemplateNewSight$onLongTouch = _logos_super$_ungrouped$WCContentItemViewTemplateNewSight$onLongTouch;if (!class_addMethod(_class, @selector(onLongTouch), (IMP)&_logos_method$_ungrouped$WCContentItemViewTemplateNewSight$onLongTouch, method_getTypeEncoding(_method))) {_logos_orig$_ungrouped$WCContentItemViewTemplateNewSight$onLongTouch = (void (*)(WCContentItemViewTemplateNewSight*, SEL))method_getImplementation(_method);_logos_orig$_ungrouped$WCContentItemViewTemplateNewSight$onLongTouch = (void (*)(WCContentItemViewTemplateNewSight*, SEL))method_setImplementation(_method, (IMP)&_logos_method$_ungrouped$WCContentItemViewTemplateNewSight$onLongTouch);}}}} }
#line 68 "Tweak.xm"
