#line 1 "Tweak.xm"
#import "iOSREMailMarker.h"

#include <logos/logos.h>
#include <objc/message.h>
@class MailboxPickerController; @class MailboxContentViewController; 
static Class _logos_superclass$_ungrouped$MailboxPickerController; static void (*_logos_orig$_ungrouped$MailboxPickerController$viewWillAppear$)(MailboxPickerController*, SEL, BOOL);static Class _logos_superclass$_ungrouped$MailboxContentViewController; static void (*_logos_orig$_ungrouped$MailboxContentViewController$megaMallMessageCountChanged$)(MailboxContentViewController*, SEL, NSConcreteNotification *);

#line 3 "Tweak.xm"



static void _logos_method$_ungrouped$MailboxPickerController$iOSREShowWhitelist(MailboxPickerController* self, SEL _cmd) {
	UIAlertController *alertController = [UIAlertController alertControllerWithTitle:@"Whitelist" message:@"Please input an email address" preferredStyle:UIAlertControllerStyleAlert];
	UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"0K" style:UIAlertActionStyleDefault handler:^(UIAlertAction * action) {
		UITextField *whitelistField = alertController.textFields.firstObject;
		if ([whitelistField.text length] != 0) [[NSUserDefaults standardUserDefaults] setObject:whitelistField.text forKey:@"whitelist"];
	}];
	UIAlertAction *cancelAction = [UIAlertAction actionWithTitle:@"Cancel" style:UIAlertActionStyleCancel handler:nil];
	[alertController addAction:okAction];
	[alertController addAction:cancelAction];
	[alertController addTextFieldWithConfigurationHandler:^(UITextField *textField) {
		textField.placeholder = @"85176878@qq.com";
		textField.text = [[NSUserDefaults standardUserDefaults] objectForKey:@"whitelist"];
	}];
	[self presentViewController:alertController animated:YES completion:nil];
}


static void _logos_super$_ungrouped$MailboxPickerController$viewWillAppear$(MailboxPickerController* self, SEL _cmd, BOOL arg1) {return ((void (*)(MailboxPickerController*, SEL, BOOL))class_getMethodImplementation(_logos_superclass$_ungrouped$MailboxPickerController, @selector(viewWillAppear:)))(self, _cmd, arg1);}static void _logos_method$_ungrouped$MailboxPickerController$viewWillAppear$(MailboxPickerController* self, SEL _cmd, BOOL arg1) {
	self.navigationItem.leftBarButtonItem = [[[UIBarButtonItem alloc] initWithTitle: @"Whitelist" style: UIBarButtonItemStylePlain target: self action:@selector(iOSREShowWhitelist)] autorelease];
	_logos_orig$_ungrouped$MailboxPickerController$viewWillAppear$(self, _cmd, arg1);
}




static void _logos_super$_ungrouped$MailboxContentViewController$megaMallMessageCountChanged$(MailboxContentViewController* self, SEL _cmd, NSConcreteNotification * arg1) {return ((void (*)(MailboxContentViewController*, SEL, NSConcreteNotification *))class_getMethodImplementation(_logos_superclass$_ungrouped$MailboxContentViewController, @selector(megaMallMessageCountChanged:)))(self, _cmd, arg1);}static void _logos_method$_ungrouped$MailboxContentViewController$megaMallMessageCountChanged$(MailboxContentViewController* self, SEL _cmd, NSConcreteNotification * arg1) {
	_logos_orig$_ungrouped$MailboxContentViewController$megaMallMessageCountChanged$(self, _cmd, arg1);
	NSMutableSet *targetMessages = [NSMutableSet setWithCapacity:600];
	NSString *whitelist = [[NSUserDefaults standardUserDefaults] objectForKey:@"whitelist"];
	MessageMegaMall *mall = [arg1 object];
	NSSet *messages = [mall copyAllMessages]; 
	for (MFLibraryMessage *message in messages)
	{
		MFMessageInfo *messageInfo = [message copyMessageInfo]; 
		for (NSString *sender in [message senders]) if (!messageInfo.read && [sender rangeOfString:[NSString stringWithFormat:@"<%@>", whitelist]].location == NSNotFound) [targetMessages addObject:message];
		[messageInfo release];
	}
	[messages release];
	[mall markMessagesAsViewed:targetMessages];
}

static __attribute__((constructor)) void _logosLocalInit() {
{Class _logos_class$_ungrouped$MailboxPickerController = objc_getClass("MailboxPickerController"); _logos_superclass$_ungrouped$MailboxPickerController = class_getSuperclass(_logos_class$_ungrouped$MailboxPickerController); { char _typeEncoding[1024]; unsigned int i = 0; _typeEncoding[i] = 'v'; i += 1; _typeEncoding[i] = '@'; i += 1; _typeEncoding[i] = ':'; i += 1; _typeEncoding[i] = '\0'; class_addMethod(_logos_class$_ungrouped$MailboxPickerController, @selector(iOSREShowWhitelist), (IMP)&_logos_method$_ungrouped$MailboxPickerController$iOSREShowWhitelist, _typeEncoding); }{ Class _class = _logos_class$_ungrouped$MailboxPickerController;Method _method = class_getInstanceMethod(_class, @selector(viewWillAppear:));if (_method) {_logos_orig$_ungrouped$MailboxPickerController$viewWillAppear$ = _logos_super$_ungrouped$MailboxPickerController$viewWillAppear$;if (!class_addMethod(_class, @selector(viewWillAppear:), (IMP)&_logos_method$_ungrouped$MailboxPickerController$viewWillAppear$, method_getTypeEncoding(_method))) {_logos_orig$_ungrouped$MailboxPickerController$viewWillAppear$ = (void (*)(MailboxPickerController*, SEL, BOOL))method_getImplementation(_method);_logos_orig$_ungrouped$MailboxPickerController$viewWillAppear$ = (void (*)(MailboxPickerController*, SEL, BOOL))method_setImplementation(_method, (IMP)&_logos_method$_ungrouped$MailboxPickerController$viewWillAppear$);}}}Class _logos_class$_ungrouped$MailboxContentViewController = objc_getClass("MailboxContentViewController"); _logos_superclass$_ungrouped$MailboxContentViewController = class_getSuperclass(_logos_class$_ungrouped$MailboxContentViewController); { Class _class = _logos_class$_ungrouped$MailboxContentViewController;Method _method = class_getInstanceMethod(_class, @selector(megaMallMessageCountChanged:));if (_method) {_logos_orig$_ungrouped$MailboxContentViewController$megaMallMessageCountChanged$ = _logos_super$_ungrouped$MailboxContentViewController$megaMallMessageCountChanged$;if (!class_addMethod(_class, @selector(megaMallMessageCountChanged:), (IMP)&_logos_method$_ungrouped$MailboxContentViewController$megaMallMessageCountChanged$, method_getTypeEncoding(_method))) {_logos_orig$_ungrouped$MailboxContentViewController$megaMallMessageCountChanged$ = (void (*)(MailboxContentViewController*, SEL, NSConcreteNotification *))method_getImplementation(_method);_logos_orig$_ungrouped$MailboxContentViewController$megaMallMessageCountChanged$ = (void (*)(MailboxContentViewController*, SEL, NSConcreteNotification *))method_setImplementation(_method, (IMP)&_logos_method$_ungrouped$MailboxContentViewController$megaMallMessageCountChanged$);}}}} }
#line 47 "Tweak.xm"
